/******************************************************************************
 Basierend auf den Libraries von Peter Fleury!

 AD-Wandler.

 Liest 3 analoge Spannungswerte ein:
 - Temperatur
 - Absolutdruck
 - Differenzdruck

 Daraus wird der Volumesntrom berechnet. Hier nur B E I S P I E L H A F T ! ! !

 Temperatur wird an AD0 gemessen
 Absolutdruck wird an AD1 gemessen
 Differenzdruck wird an AD2 gemessen
 
*******************************************************************************/

#include<avr/io.h>

void lcd_puts();
void lcd_gotoxy();

/*****************************************
******************************************
**										**
**				BERECHNUNG				**
**										**
******************************************
******************************************/


/*void berechnen_VStrom (float temp, float absdruck, float diffdruck) 
{

	float volumenstrom; //Ergebnisvariable Voluemstromberechnung
	char Buffer[20];
	  	
	// Activate ADC with Prescaler 16 --> 1Mhz/16 = 62.5kHz
  	//ADCSRA = _BV(ADEN) | _BV(ADPS0) | _BV(ADPS1);
  
  	while(1) 
  		{  
			volumenstrom = 27.3;
//			((temp + absdruck) / diffdruck);
			sprintf(Buffer, "%5.2f", volumenstrom);
    		lcd_puts(Buffer);
  		}

}*/

/*****************************************
******************************************
**										**
**				FUNCTIONS				**
**										**
******************************************
******************************************/


/********************
*    Temperatur     *
********************/

void lese_Temperatur(void)
{
	ADMUX = 0xE0;
	ADCSRA = 0x85;  		//4MHz:32;

	int x=0;
	char Buffer[20];

    //Start conversion
    ADCSRA |= (1<<ADSC);
    
    // wait until converstion completed
    while (ADCSRA & _BV(ADSC) ) {}
    
    //get converted value
    x = ADCH;

  	sprintf( Buffer, "%3d", x);
  	lcd_puts(Buffer);
	//return x;

}

/********************
*   Absolutdruck    *
********************/

float lese_Absolutdruck(void)
{
	float absolutdruck=0;

	/*
	// Select pin ADC1 using MUX
    ADMUX = 0x02;
    
    //Start conversion
    ADCSRA |= _BV(ADSC);
    
    // wait until converstion completed
    while (ADCSRA & _BV(ADSC) ) {}
    
    // get converted value
    x = ADCW; */ 
    
    // output the higher 8 bits
    absolutdruck = 13.7;  //~x>>2;

	return absolutdruck;

}

/********************
*  Differenzdruck   *
********************/

float lese_Differenzdruck(void)
{
	float differenzdruck=0;

	/*
	// Select pin ADC2 using MUX
    ADMUX = 0x04;
    
    //Start conversion
    ADCSRA |= _BV(ADSC);
    
    // wait until converstion completed
    while (ADCSRA & _BV(ADSC) ) {}
    
    // get converted value
    x = ADCW;*/  
    
    // output the higher 8 bits
    differenzdruck = 7.8;		//~x>>2;

	return differenzdruck;

}

